// Main.cs created with MonoDevelop
// User: francescocarsana at 9:38 AM 2/15/2008

using System;
using System.IO;
using System.Xml;
using System.Threading;
using LanmarkControls.LECBroadcast;
using LanmarkControls.LECSession;

namespace test
{
   class MainClass
   {
      private static Broadcast b;
      private static int       clientID;
      private static string    serverVer;
      private static string    fpgaVer;
      private static string    addressCurr;
      private static int       portCurr;
      public static string	    testJob = @"<Data type='JobData' rev='1.0'>
<Set id='JumpSpeed'>15,30</Set>
<Set id='MarkSpeed'>15,10</Set>
<JumpAbs>-5000,-5000</JumpAbs>
<MarkAbs>-5000,5000</MarkAbs>
<MarkAbs>5000,5000</MarkAbs>
<MarkAbs>5000,-5000</MarkAbs>
<MarkAbs>-5000,-5000</MarkAbs>
</Data>";      

	   
	   public static void ReadSysInfo(string strECName, out string strSysInfo)
		{
			uint	err = 0;
			strSysInfo = "";

			err = 1;
			while (0 != err) {
				err = b.getBroadcastData(clientID, strECName, 0x00000001, out strSysInfo);
				if (0 == err) {
               //Console.WriteLine("\n\n SUCCESS getBroadcastData('{0}', 0x00000001) piData=\n\n {1}\n", strECName, strSysInfo);
               Console.WriteLine("\n\n SUCCESS getBroadcastData('" + strECName.ToString() + "', 0x00000001)\n");

					//	Get XML value from this Elements out of DataType 0x00000001
               LanmarkControls.LECUtils.Utils.ReadFromXML(strSysInfo, 0, "AVer", null, out serverVer);
               LanmarkControls.LECUtils.Utils.ReadFromXML(strSysInfo, 0, "FPGAFirmVer", null, out fpgaVer);
               LanmarkControls.LECUtils.Utils.ReadFromXML(strSysInfo, 0, "IP", null, out addressCurr);
					string	strTemp = "";
					LanmarkControls.LECUtils.Utils.ReadFromXML(strSysInfo, 0, "Port", null, out strTemp);
					portCurr = Convert.ToInt32(strTemp);
				}
				else {
					Console.Write(".");
					Thread.Sleep(1000);
				}
			}
		}
		


		public static void ReadStatInfo(string strECName, out string strStatInfo)
		{
			uint	err = 0;

			strStatInfo = "";

			err = 1;
			while (0 != err)
			{
				err = b.getBroadcastData(clientID, strECName, 0x00000007, out strStatInfo);
				if (0 == err) {
               //Console.WriteLine("\n\n SUCCESS getBroadcastData('{0}', 0x00000007) piData=\n\n {1}\n",	strECName, strStatInfo);
               Console.WriteLine("\n\n SUCCESS getBroadcastData('" + strECName.ToString()+ "', 0x00000007)\n");
				}
				else {
					Console.Write(".");
					Thread.Sleep(1000);
				}
			}
		}


   
      public static void Main(string[] args)
      {
         string    localIP = "0.0.0.0";
         string    broadcastIP = "224.168.100.2";
         string    serverXML = "";
			int       serverCount = 0;      
         
         // leggo l'indirizzo IP del client
         //Console.Write("Local IP Address: ");
		   //localIP = Console.ReadLine();
		   
		   //ECUtils.WriteRegistry();  // da fare solo la prima volta che si esegue l'applicazione sul sistema (da utente root)
      
         b = new Broadcast();
      
         // inizializzo l'oggetto broadcast
         try
			{
				Console.WriteLine("Creating BROADCAST object.");				

				if (b.clientAttachBroadcast(broadcastIP, localIP, 11000, ref clientID) != 0) {
               Console.WriteLine("   clientAttachBroadcast(" + localIP + ") FAILED. clientID= " + clientID);
					return;
				}
				
            Console.WriteLine("   clientAttachBroadcast(" + localIP + ") Suceeded. clientID= " + clientID);
			
			}
			catch(Exception ex)
			{
				Console.WriteLine("\nUnexpected LECBroadcast server exception: " + ex.Message);
			}
			
			// richiedo la lista delle schede EC-1000

         for (int i = 0; i < 10; i++) {
				if (b.getLECServerList(clientID, out serverCount, out serverXML) != 0) {
				   Console.WriteLine("No Servers found!\n");
				   return;
				}
				Console.Write("{0}", serverCount);
				Thread.Sleep(1000);
			}
			Console.WriteLine("\nPoll found "+ serverCount.ToString() +" target(s)\n");
			
			string[] addresses = new string[serverCount];	// from LECServerList
			int[] 	ports = new int[serverCount];
			
			// loop thru each target found
			for (int i = 0; i < serverCount; i++) {
			   string data, name;
			   
			   //	Get XML Attribute 'name' value for Element LEC from ServerList
				LanmarkControls.LECUtils.Utils.ReadFromXML(serverXML, i, "LEC", "name", out name);

				ReadStatInfo(name, out data);
				Console.WriteLine(data);

				// Get current Target's IPAddress and PortNumber
				ReadSysInfo(name, out data);
				addresses[i] = addressCurr;
				ports[i] = portCurr;
				Console.WriteLine(data);
			}
			
			for (int i = 0; i < serverCount; i++)  {
			   Session session = new Session();
			   string strUserName = "";
            string strPassword = "";

            if (session != null) {
               if (0 == session.loginSession(localIP, addresses[i], ports[i], strUserName, strPassword, 10000)) {
                  Console.WriteLine("\nLogged in to " + addresses[i]);
                  
                  Console.WriteLine("\nSending sample job...");
                  if (session.sendStreamData(testJob, 10000) == 0) {
                     Console.WriteLine("Job sent!");
                  }
                  else {
                     Console.WriteLine("ERROR sending job!");
                  }
                  
                  session.logoutSession(10000);
                  Console.WriteLine("\nLogged out to " + addresses[i]);
               }
               else {
                  Console.WriteLine("ERROR: failed to login to target: " + addresses[i], "LecSession client");
               }
			      
					break;
				}
			}
			
			b.clientDetachBroadcast(clientID);
      }
   }
}
